/*
 * Required functions exported by the wlc_led.c
 * to common (os-independent) driver code.
 *
 * Copyright 2005-2006, Broadcom Corporation
 * All Rights Reserved.                
 *                                     
 * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
 * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
 * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
 *
 * $Id$
 */

#ifndef _wlc_led_h_
#define _wlc_led_h_


#ifdef WLLED
extern led_info_t *wlc_led_attach(wlc_pub_t *pub, uint d11_unit, void *wlc);
extern void wlc_led_detach(led_info_t *ledh);
extern void wlc_led_init(led_info_t *ledh, uint32 *gpio);
extern void wlc_led_event(led_info_t *ledh);
extern void wlc_led_timer(led_info_t *ledh);
extern void wlc_led_blink_timer(led_info_t *ledh);
extern void wlc_led_radioset(led_info_t *ledh, bool led_state);
extern void wlc_led_activityset(led_info_t *ledh, bool led_state);
#else
#define wlc_led_attach(a, b, c) (led_info_t *)0x0dadbeef
#define wlc_led_detach(a) do {} while (0)
#define wlc_led_init(a, b) do {} while (0)
#define wlc_led_event(a) do {} while (0)
#define wlc_led_timer(a) do {} while (0)
#define wlc_led_blink_timer(a) do {} while (0)
#define wlc_led_radioset(a, b) do {} while (0)
#define wlc_led_activityset(a, b) do {} while (0)
#endif /* WLLED */

#endif	/* _wlc_led_h_ */
